import { world, system } from "@minecraft/server";

export function voidStaffFunc() {
    system.runInterval(() => {
        world.getAllPlayers().forEach(player => {
            player.dimension.getEntities().forEach(entity => {
                try {
                    if (entity.typeId == "bey:void_staff_teleporter_1") {
                        entity.dimension.spawnParticle("bey:void_staff_particle", entity.location);
                        entity.dimension.spawnParticle("bey:void_staff_particle_beam", entity.location)
                    }
                }
                catch { }
            })
        })
    }, 5)

    system.runInterval(() => {
        world.getAllPlayers().forEach(player => {
            const playerLoc = {
                x: Math.floor(player.location.x),
                y: Math.floor(player.location.y),
                z: Math.floor(player.location.z),
            };

            let isOnVoidEntity = false;
            player.dimension.getEntities().forEach(entity => {

                if (entity.typeId == "bey:void_staff_teleporter_1") {

                    entity.dimension.getEntities({ location: entity.location, maxDistance: 15 }).forEach(entityPlayer => {
                        if (entityPlayer.typeId == "minecraft:player") {
                            entityPlayer.addTag("inTp1Range");
                        }
                    })
                    entity.dimension.getEntities({ location: entity.location, minDistance: 15.1 }).forEach(entityPlayer => {
                        if (entityPlayer.typeId == "minecraft:player") {
                            entityPlayer.removeTag("inTp1Range");
                        }
                    })

                    const voidEntityLoc = {
                        x: Math.floor(entity.location.x),
                        y: Math.floor(entity.location.y),
                        z: Math.floor(entity.location.z),
                    };

                    if (
                        playerLoc.x === voidEntityLoc.x &&
                        playerLoc.y === voidEntityLoc.y &&
                        playerLoc.z === voidEntityLoc.z
                    ) {
                        isOnVoidEntity = true;

                        if (!player.hasTag("Teleported")) {
                            const nearbyEntities = entity.dimension.getEntities({
                                location: entity.location,
                                maxDistance: 15,
                            });

                            for (const entity2 of nearbyEntities) {
                                if (
                                    (entity.typeId === "bey:void_staff_teleporter_1" && entity2.typeId === "bey:void_staff_teleporter_2")
                                ) {
                                    const targetLoc = {
                                        x: Math.floor(entity2.location.x),
                                        y: Math.floor(entity2.location.y),
                                        z: Math.floor(entity2.location.z),
                                    };

                                    player.runCommandAsync(`/camera @s fade time 1 2 1`)
                                    player.addEffect("slowness", 50, { amplifier: 6 })
                                    player.playSound("beacon.activate", { location: player.location });
                                    system.runTimeout(() => {
                                        player.runCommandAsync(`/tp @s ${targetLoc.x} ${targetLoc.y} ${targetLoc.z}`);
                                        player.playSound("mob.endermen.portal", { location: player.location });
                                    }, 30)
                                    player.addTag("Teleported");
                                    break;
                                }
                            }
                        }
                    }
                }
            });

            if (!isOnVoidEntity) {
                player.removeTag("Teleported");
            }
        });
    });
}
