import { world } from "@minecraft/server"

export function weaponMining() {
    world.afterEvents.playerBreakBlock.subscribe((event) => {
        let player = event.player;
        let playerHeld = player.getComponent(`equippable`).getEquipment(`Mainhand`);

        let block = event.block;
        const { x, y, z } = block.location;

        if (playerHeld && playerHeld.typeId == "bey:war_pickaxe") {
            for (let dx = -1; dx <= 1; dx++) {
                for (let dy = -1; dy <= 1; dy++) {
                    for (let dz = -1; dz <= 1; dz++) {
                        const targetBlock = block.dimension.getBlock({ x: x + dx, y: y + dy, z: z + dz });
                        if (targetBlock) {
                            if (!targetBlock.permutation.matches("minecraft:bedrock") &&
                                !targetBlock.permutation.matches("minecraft:end_portal_frame")
                            )
                                player.runCommandAsync(
                                    `setblock ${x + dx} ${y + dy} ${z + dz} air destroy`
                                );
                            player.dimension.spawnParticle("minecraft:camera_shoot_explosion", { x, y, z });
                            player.runCommandAsync("playsound random.explode @s ~ ~ ~ 0.5");
                        }
                    }
                }
            }
        }
    })
}